#ifndef _PARTICLE_H_
#define _PARTICLE_H_

#include <cstring>

class PParticle 
{
  public:
    PParticle();
    ~PParticle();
    int SetDimension( int d=1 ); // default dimension=1, returns 0 on success, -1 on error
    void SetX( float x, int d=0 );
    void SetV( float v, int d=0 );
    void SetPbest( float best );
    void SetPbestx( float x, int d=0 );
    
    int GetDimension();
    float GetX( int d=0 );
    float GetV( int d=0 );
    float GetPbest();
    float GetPbestx( int d=0 );
    
  private:
    int _dimension;
    float *_x;
    float *_v;
    float _pbest;
    float *_pbestx;
};

#endif
